<?php

include_once('extern/rfc822.php');

function warning($text)
{
  global $cfg;
  $ret = '<p class="warn"><img src="'.$cfg['basepath'].
    'achtung.gif" width="33" height="32" alt="Achtung!">&nbsp;&nbsp;';
  $ret .= $text .'</p>';
  return $ret;
}

function information($text)
{
  global $cfg;
  $ret = '<p class="info"><img src="'.$cfg['basepath'].
    'information.gif" width="31" height="31" alt="Info">&nbsp;&nbsp;';
  $ret .= $text .'</p>';
  return $ret;
}

function pageheader()
{
  global $cfg;
  global $zlist;
  global $_POST;
  global $_SERVER;

  $ret .= '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
  $ret .= '<html lang="de">';
  $ret .= '<head>';
  if (isset($zlist['newspaper']))
    $ret .= sprintf('<title>Zeitungsliste: %s</title>', $zlist['newspaper']);
  elseif (isset($zlist['tag']))
    $ret .= sprintf('<title>Zeitungsliste: Tag %s</title>', $zlist['tag']);
  else
    $ret .= '<title>Zeitungsliste</title>';
  $ret .= '<meta http-equiv="Content-Type" content="text/html; charset=utf-8">';
  $ret .= '<meta name="Author" content="joey@infodrom.org (Joey Schulze)">';
  $ret .= '<meta name="Language" content="de">';
  
  if ($zlist['page'] == 'index') {
    $ret .= '<meta name="Keywords" content="Zeitung, Zeitungen, Liste, Zeitungsliste, Online-Zeitungen, Zeitungen im Web, Forum, Community, '.
      'Liste aller Zeitungen">';
    $ret .= sprintf('<link rel="alternate" type="application/rss+xml" title="Zeitungen" href="%szeitungen.rdf">', $cfg['basepath']);
  } elseif ($cfg['dir'] == 'zeitung') {
    $ret .= '<meta name="Keywords" content="Zeitung, Zeitungsliste, Online-Zeitung, Zeitung im Web, Forum, Community, '.
      $zlist['newspaper'] . ', ' . $zlist['city'] . '">';
  }

  if (is_spider())
    $ret .= '<meta name="Robots" content="index,follow">';
  $ret .= '<meta name="Copyright" content="(c) 2008 Information & Consulting">';
  $ret .= sprintf('<link href="%smain.css" rel="stylesheet" type="text/css">', $cfg['basepath']);
  $ret .= sprintf('<link rel="icon" href="%sfavicon.ico" type="image/x-icon">', $cfg['basepath']);
  $ret .= sprintf('<link rel="shortcut icon" href="%sfavicon.ico" type="image/x-icon">', $cfg['basepath']);

  if (isset($zlist['redirect']))
    $ret .= sprintf('<meta http-equiv="refresh" content="7; URL=%s%s">',
		    $cfg['home'], $zlist['redirect']);

  $ret .= '</head>';

  if (javascript_ok()) {
    $ret .= sprintf('<script type="text/javascript" src="%szlist.js"></script>', $cfg['basepath']);
    $ret .= sprintf('<script type="text/javascript">var zlist_urlbase = "%s";</script>', $cfg['basepath']);
  }

  $ret .= '<body>';
  $ret .= '<div class="banner"><h1 class="none"><a href="http://www.debian.org/">Zeitungen online im Netz</a></h1></div>';

  $ret .= '<div class="status">';

  $ret .= '<div class="homestatus"><a href="'.$cfg['home'].'">Home</a>';
  if ($cfg['path'] != 'contact.html')
    $ret .= sprintf('&nbsp;&nbsp;&nbsp;<a href="%scontact.html">Kontakt</a>', $cfg['basepath']);
  if (is_spider())
    $ret .= sprintf('&nbsp;&nbsp;&nbsp;<a href="%ssitemap.html">Sitemap</a>', $cfg['basepath']);
  $ret .= '</div>';

  if (logged_in()) {
    if ($cfg['path'] != "logout.html") {
      $ret .= '<div class="logstatus">';
      if ($cfg['path'] != "options.html")
	$ret .= sprintf('<a href="%soptions.html">Einstellungen</a>&nbsp;&nbsp;&nbsp;',
			$cfg['basepath']);
      $ret .= sprintf('<a href="%slogout.html">Abmelden</a>',
		      $cfg['basepath']);
      $ret .= '</div>';
    }
  } else {
    if (($cfg['path'] != "login.html" && $cfg['path'] != "activate.html") ||
	($cfg['path'] == 'login.html' && isset($_POST['sendnew'])))
      $ret .= sprintf('<div class="logstatus"><a href="%slogin.html">Anmelden</a></div>',
		      $cfg['basepath']);
  }
  $ret .= sprintf('<div class="userstatus">%s</div>', userstatus());
  $ret .= '</div>';

  $ret .= '<div class="page">';
  if ($_SERVER['SERVER_NAME'] == 'www.zeitungsliste.de' && javascript_ok())
    $ret .= "\n" . load_template('addsense.js');

  return $ret;
}

function layout_page($body)
{
  global $zlist;

  $ret = '<div class="info">';
  if (is_array($zlist['info'])) {
    include_once('info.inc');
    foreach ($zlist['info'] as $func)
      $ret .= $func();
  }

  $ret .= '</div>';

  $ret .= '<div class="main">';
  $ret .= $body;
  $ret .= '</div>';
  return $ret;
}

function layout_bookmarks($rel, $title)
{
  global $cfg;

  // Mehr auf http://www.bikeshops.de/Bikeshops/BikeGuide/BikeGuideWertgarantie.asp
  $bookmarks = array(
		     array('text' => 'Mister Wong',
			   'icon' => 'link_misterwong.gif',
			   'link' => 'http://www.mister-wong.de/index.php?action=addurl&amp;bm_url=@url@&amp;bm_description=@title@'),
		     array('text' => 'Delicious',
			   'icon' => 'link_delicious.gif',
			   'link' => 'http://del.icio.us/post?v=4&amp;noui&amp;url=@url@&amp;title=@title@'),
		     array('text' => 'Google Bookmarks',
			   'icon' => 'link_google.gif',
			   'link' => 'http://www.google.com/bookmarks/mark?op=add&amp;hl=de&amp;bkmk=@url@&amp;title=@title@'),
		     array('text' => 'Yahoo Web',
			   'icon' => 'link_yahoo.gif',
			   'link' => 'http://myweb2.search.yahoo.com/myresults/bookmarklet?u=@url@&amp;t=@title@'),
		     array('text' => 'Technorati',
			   'icon' => 'link_technorati.gif',
			   'link' => 'http://technorati.com/faves?add=@url@'),
		     array('text' => 'Digg it',
			   'icon' => 'link_digg.gif',
			   'link' => 'http://digg.com/submit?phase=2&amp;url=@url@&amp;title=@title@'),
		     array('text' => 'Yigg',
			   'icon' => 'link_yigg.gif',
			   'link' => 'http://yigg.de/neu?action=addurl&amp;exturl=@url@&amp;exttitle=@title@'),
		     array('text' => 'Taggle',
			   'icon' => 'link_taggle.gif',
			   'link' => 'http://taggle.de/addLinkDetails?mAddress=@url@&amp;title=B@title@&amp;submitted=Weiter'),
		     array('text' => 'Linkarena',
			   'icon' => 'link_linkarena.gif',
			   'link' => 'http://www.linkarena.com/linkadd.php?linkName=@title@&amp;linkURL=@url@'),
		     array('text' => 'OneView',
			   'icon' => 'link_oneview.gif',
			   'link' => 'http://www.oneview.de/quickadd/neu/addBookmark.jsf?URL=@url@&amp;title=@title@'),
		     array('text' => 'folk it',
			   'icon' => 'link_folkd.gif',
			   'link' => 'http://www.folkd.com/submit/@url@'),
		     array('text' => 'Facebook',
			   'icon' => 'link_facebook.gif',
			   'link' => 'http://www.facebook.com/sharer.php?u=@url@&amp;title=@title@'),
		     array('text' => 'Blinklist',
			   'icon' => 'link_blinklist.gif',
			   'link' => 'http://www.blinklist.com/index.php?Action=Blink/addblink.php&Url=@url@&Description=@title@'),
		     array('text' => 'Furl',
			   'icon' => 'link_furl.gif',
			   'link' => 'http://www.furl.net/storeIt.jsp?t=@title@&u=@url@'),
		     array('text' => 'Reddit',
			   'icon' => 'link_reddit.gif',
			   'link' => 'http://reddit.com/submit?url=@url@&title=@title@'),
		     array('text' => 'Spurl',
			   'icon' => 'link_spurl.gif',
			   'link' => 'http://www.spurl.net/spurl.php?url=@url@&title=@title@'),
		     array('text' => 'Shadows',
			   'icon' => 'link_shadows.gif',
			   'link' => 'http://www.shadows.com/features/tcr.htm?url=@url@&title=@title@'),
		     array('text' => 'newsvine',
			   'icon' => 'link_newsvine.gif',
			   'link' => 'http://www.newsvine.com/_wine/save?popoff=1&u=@url@&tags=&blurb=@title@'),
		     array('text' => 'CXWeb',
			   'icon' => 'link_cxweb.gif',
			   'link' => 'http://www.cxweb.de/login/?action=add&amp;address=@url@&amp;title=@title@'),
		     array('text' => 'Simpy',
			   'icon' => 'link_simpy.gif',
			   'link' => 'http://www.simpy.com/simpy/LinkAdd.do?title=@title@&amp;href=@url@'),
		     array('text' => 'Ma.Gnolia',
			   'icon' => 'link_magnolia.gif',
			   'link' => 'http://ma.gnolia.com/bookmarklet/add?url=@url@&amp;title=@title@&amp;description=&amp;tags='),
		     array('text' => 'StumbleUpon',
			   'icon' => 'link_stumbleupon.gif',
			   'link' => 'http://www.stumbleupon.com/submit?url=@url@&amp;title=@title@'),
		     array('text' => 'linksilo.de',
			   'icon' => 'link_linksilo.gif',
			   'link' => 'http://www.linksilo.de/index.php?area=bookmarks&amp;func=bookmark_new&amp;addurl=@url@&amp;addtitle=@title@'),
		     array('text' => 'bookmarks.cc',
			   'icon' => 'link_bookmarkscc.gif',
			   'link' => 'http://www.bookmarks.cc/bookmarken.php?action=neu&amp;url=@url@&amp;title=@title@'),
		     );

  $url = $cfg['home'] . $rel;

  $ret = '<div class="social_bookmarks">Lesezeichen: ';

  foreach ($bookmarks as $bm) {
    $ret .= sprintf('<a href="%s" title="%s"><img src="%sbookmarks/%s" width="16" height="16" alt="%s" name="%s" border="0"></a>',
		    str_replace(array('@url@', '@title@'),
				array(htmlspecialchars($url), htmlspecialchars($title)),
				$bm['link']),
		    $bm['text'],
		    $cfg['basepath'], $bm['icon'], $bm['text'], $bm['text']);
  }

  $ret .= '</div>';

  return $ret;
}

/*
 * Add links to the main page for web spider so that they get the entire database
 */
function layout_sitemap()
{
  global $_SESSION;
  global $_SERVER;
  global $cfg;

  if (!is_spider())
    header('Location: ' . $cfg['home']);

  $ret = '<h1>Sitemap der Zeitungsliste</h1>';

  $query = 'SELECT tagname FROM tags ORDER BY lower(tagname)';

  $sth = db_query($query);

  if ($sth !== false && pg_num_rows($sth) > 0) {
    $ret .= '<h3>User-Tags (Merkmale)</h3>';
    $ret .= '<ul class="gold">';

    for ($i=0; $i < pg_num_rows($sth); $i++) {
      $row = pg_fetch_array($sth, $i);

      $ret .= sprintf('<li><a href="%stag/%s.html">%s</a></li>',
		      $cfg['basepath'], urlencode($row['tagname']),
		      $row['tagname']);
    }

    $ret .= '</ul>';
  }

  $query = 'SELECT id,name,city FROM zeitungen WHERE deleted IS false ORDER BY name';

  $sth = db_query($query);

  if ($sth !== false && pg_num_rows($sth) > 0) {
    $ret .= '<h3>Zeitungen und Magazine</h3>';
    $ret .= '<ul class="gold">';
    for ($i=0; $i < pg_num_rows($sth); $i++) {
      $row = pg_fetch_array($sth, $i);

      $ret .= sprintf('<li><a href="%szeitung/%d.html">%s</a>, %s</li>',
		      $cfg['basepath'], $row['id'], $row['name'], $row['city']);
    }
    $ret .= '</ul>';
  }

  $query = 'SELECT id,topic FROM topics ORDER BY created';

  $sth = db_query($query);

  if ($sth !== false && pg_num_rows($sth) > 0) {
    $ret .= '<h3>Diskussionen</h3>';
    $ret .= '<ul class="gold">';
    for ($i=0; $i < pg_num_rows($sth); $i++) {
      $row = pg_fetch_array($sth, $i);

      $ret .= sprintf('<li><a href="%stopic/%d.html">%s</a></li>',
		      $cfg['basepath'], $row['id'], $row['topic']);
    }
    $ret .= '</ul>';
  }

  return $ret;
}

function layout_showpaper($archived=false)
{
  global $_GET;
  global $zlist;

  if (!isset($_GET['zeitung']) || !is_numeric($_GET['zeitung']))
    $ret = warning('Keine Zeitung oder Magazin gefunden.');
  else {
    $zid = $_GET['zeitung'];
    $details = format_newspaper($zid, true);
    if ($details === false)
      $ret .= warning('Keine Zeitung oder Magazin gefunden.');
    else {
      $zlist['zid'] = $zid;
      $ret .= $details;
      if (!$archived) {
	hits_inc ($zid);
	$ret .= format_board($zid);
      } else {
	$ret .= format_board($zid, $archived);
      }
      $ret .= layout_bookmarks(sprintf('zeitung/%d.html', $zid), $zlist['newspaper']);
    }
  }

  return $ret;
}

function layout_archive()
{
  global $zlist;
  global $_GET;
  global $cfg;

  if (!isset($_GET['archiv']) || !is_numeric($_GET['archiv']))
    $ret = warning('Keine Zeitung oder Magazin gefunden.');
  else {
    $zid = $_GET['archiv'];
    $details = format_newspaper($zid, true);
    if ($details === false)
      $ret .= warning('Keine Zeitung oder Magazin gefunden.');
    else {
      $zlist['zid'] = $zid;
      $ret .= $details;

      $query = sprintf('SELECT id,topic FROM topics ' .
		       'WHERE zeitung = %d ORDER BY created DESC',
		       $_GET['archiv']);

      $sth = db_query($query);

      if (!$sth || pg_num_rows ($sth) == 0)
	$ret .= warning('Kein Archiv gefunden.');
      else {
	$ret .= '<p><ul class="gold">';
	for ($i=0; $i < pg_num_rows ($sth); $i++) {
	  $row = pg_fetch_array($sth, $i);
	  $ret .= sprintf('<li><a href="%stopic/%d.html">%s</a></li>',
			  $cfg['basepath'], $row['id'], $row['topic']);
	}
	$ret .= '</ul></p>';
      }
    }
  }

  return $ret;
}

function layout_showtag()
{
  global $cfg;
  global $zlist;
  global $_GET;

  if (!isset($_GET['tag']))
    $ret = warning('Keine derartiges Merkmal gefunden.');
  else {
    $tagname = $_GET['tag'];
    $ret .= '<h3>Merkmal <span class="tag">' . $tagname . '</span></h3>';

    $query = sprintf("SELECT zeitungen.id,name,count(uid) AS count FROM zeitungen " .
		     "JOIN zeitung_tags ON zeitung = id " .
		     "JOIN tags ON tag = tags.id " .
		     "WHERE tagname = '%s' " .
		     "GROUP BY zeitungen.id,name ORDER BY count DESC",
		     pg_escape_string($tagname));

    $sth = db_query($query);

    $zlist['tag'] = htmlspecialchars($tagname);
    if (!$sth || pg_num_rows ($sth) == 0) {
      $ret .= warning('Keine Zeitungen oder Magazine mit diesem Merkmal gefunden.');
      unset($zlist['newspaper']);
    } else {
      $headlines = array('Mäßige','Mittelmäßige','Gute','Häufige','Häufigste');
      $oldtag = -1;

      for ($i=0; $i < pg_num_rows ($sth); $i++) {
	$row = pg_fetch_array ($sth, $i);
	$tag = tag_class($row['count']);

	if ($oldtag != $tag) {
	  if ($oldtag != -1)
	    $ret .= '</ul>';
	  $ret .= sprintf('<h3 class="tag%d">%s Bewertungen</h3>', $tag, $headlines[$tag]);
	  $ret .= '<ul class="gold">';
	  $oldtag = $tag;	
	}

	$ret .= sprintf('<li><a href="%szeitung/%d.html">%s</a></li>',
			$cfg['basepath'], $row['id'], $row['name'], $row['city']);
      }
      $ret .= '</ul>';

      $ret .= layout_bookmarks(sprintf('tag/%s.html', htmlspecialchars($tagname)), 'Merkmal '.$tagname);
    }
  }

  return $ret;
}

function layout_topic()
{
  global $zlist;
  global $_GET;

  if  (!isset($_GET['topic']) || !is_numeric($_GET['topic']))
    $ret = warning('Keine passende Diskussion gefunden.');
  else {
    $discussion = format_topic($_GET['topic']);

    if (isset($zlist['zid'])) {
      $ret .= format_newspaper($zlist['zid'], true);

      if ($zlist['archived'])
	$ret .= '<h3>Abgeschlossene Diskussion</h3>';
      else
	$ret .= '<h3>Diskussion</h3>';
    }
    $ret .= $discussion;
    if (isset($zlist['zid']))
      $ret .= layout_bookmarks(sprintf('topic/%d.html', $zlist['zid']), $zlist['topic']);
  }

  return $ret;
}

function notfound()
{
  header("HTTP/1.0 404 Not Found");

  return warning('Diese Seite existiert nicht!');
}

function contact_send($topic, $email, $body)
{
  global $cfg;
  global $_SESSION;
  global $_SERVER;

  $header = array();
  if (!empty($email)) {
    if (isset($_SESSION['uid']))
      $header[] = sprintf('Reply-To: %s <%s>',
			  strlen($_SESSION['realname'])?$_SESSION['realname']:$_SESSION['nickname'],
			  $email);
    else
      $header[] = 'Reply-To: ' . $email;
  }

  $body .= "\n\n"
    ."HTTP_USER_AGENT: " . $_SERVER['HTTP_USER_AGENT'] . "\n"
    ."REMOTE_ADDR    : " . $_SERVER['REMOTE_ADDR'] . "\n";

  if (isset($_SESSION['uid']))
    $body .= "Nickname       : " . $_SESSION['nickname'] . "\n";

  $subject = str_replace(array('<', '>', '(', ')', '$', '/', '%', '\\', '#', ';', '&'), '', $topic);

  sendmail($cfg['mailto'], '', $subject, $body, $header);
}

function process_contact()
{
  global $_SERVER;
  global $_POST;

  if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if (empty($_POST['topic']))
      $ret = warning('Sie haben keinen Titel für die Nachricht angegeben!');
    elseif (empty($_POST['body']))
      $ret = warning('Sie haben keinen Text der Nachricht angegeben!');
    elseif (!empty($_POST['email']) && !is_valid_email_address($_POST['email']))
      $ret = warning('Die angegebene Mail-Adresse ist ungültig.');
    else {
      contact_send($_POST['topic'], $_POST['email'], $_POST['body']);
      $ret = information('Die Nachricht wurde an den Chef geschickt.');
      $ret .= '<p>Die Bearbeitung kann eine Weile dauern.  Wenn Sie eine '.
	'Antwort erwarten, sollte diese in den nächsten Tagen an die von '.
	'Ihnen angegebene Adresse geschickt werden.</p>';
      return $ret;
    }
    $replace = array('topic' => $_POST['topic'],
		     'email' => $_POST['email'],
		     'body' => $_POST['body']);
  } elseif ($_SERVER['REQUEST_METHOD'] == 'GET') {
    if (isset($_SESSION['email']))
      $replace = array('email' => $_SESSION['email']);
    else
      $replace = array();
  }

  return load_javascript('contact.js') . load_template('contact.html', $replace);
}

?>